"""
Copyright 2023-2023 VMware Inc.
SPDX-License-Identifier: Apache-2.0

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at
    http://www.apache.org/licenses/LICENSE-2.0
Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""

from typing import Callable, Union

from hcs_core.ctxp import profile

from . import auth as auth
from .ez_client import EzClient


def hcs_client(url: Union[str, Callable]) -> EzClient:
    if not url:
        url = profile.current().hcs.url
    if isinstance(url, str) and url.endswith("/"):
        url = url[:-1]

    return EzClient(url, lazy_oauth_client=auth.oauth_client)
